#include "rgbeio.h"
#include <QByteArray>
#include <pfs.h>
#include <stdlib.h>

#ifndef _WIN32
QByteArray readRGBEfile (const char * filename) {
	char *pfshdr;
	size_t size;
	FILE *fpout=open_memstream (&pfshdr, &size);
#else
void readRGBEfile (const char * filename,const char* outfilename) {
	FILE *fpout=fopen(outfilename,"wb");
#endif
	pfs::DOMIO pfsio;
	FILE *inputRGBEfile=fopen(filename,"rb");
	RGBEReader reader( inputRGBEfile );
	pfs::Frame *frame = pfsio.createFrame( reader.getWidth(), reader.getHeight() );
	pfs::Channel *X, *Y, *Z;
	frame->createXYZChannels( X, Y, Z );
	reader.readImage( X, Y, Z );
    pfs::transformColorSpace( pfs::CS_RGB, X, Y, Z, pfs::CS_XYZ, X, Y, Z );
	frame->getTags()->setString("LUMINANCE", "RELATIVE");
	frame->getTags()->setString( "FILE_NAME", filename );
	pfsio.writeFrame( frame, fpout );
// #ifdef _WIN32
	pfsio.freeFrame( frame );
// #endif

	fclose(fpout);
	fclose(inputRGBEfile);
#ifndef _WIN32
	QByteArray toreturn;
	toreturn=QByteArray::fromRawData(pfshdr,size); //shallow copy
// 	free(pfshdr); //since fromRawData is shallow copy, I cannot free it.
	return toreturn;
#endif
// 	qDebug("size=%d",toreturn.size());
}
