#include <pfs.h>
#include <QByteArray>

#include "rgbeio.h"
#ifdef _WIN32
void writeRGBEfile (const char* infilename,const char* outfilename) {
	FILE *inputfp=fopen(infilename,"rb");
#else
void writeRGBEfile (QByteArray inqba,const char* outfilename) {
	assert(inqba.size()!=0);
	FILE *inputfp=fmemopen(inqba.data(), (size_t)(inqba.size()), "r");
#endif
	pfs::DOMIO pfsio;
	FILE *outfp=fopen(outfilename,"wb");
	RGBEWriter writer(outfp);
	pfs::Frame *frame = pfsio.readFrame(inputfp);
	pfs::Channel *X, *Y, *Z;
	frame->getXYZChannels( X, Y, Z );
	if( X==NULL || Y==NULL || Z==NULL ) {       // No color
		throw pfs::Exception( "Missing X, Y, Z channels in the PFS stream" );
	}
	pfs::transformColorSpace( pfs::CS_XYZ, X, Y, Z, pfs::CS_RGB, X, Y, Z );
	writer.writeImage( X, Y, Z );
// #ifdef _WIN32
// 	pfsio.freeFrame( frame );
// #endif
	fclose(inputfp);
	fclose(outfp);
}
