#ifndef  CREATEHDR_H
#define CREATEHDR_H

#include <QString>
#include <QList>
#include <QImage>

#include "responses.h"
#include "robertson02.h"
#include "icip06.h"

  enum TWeight
  { TRIANGULAR, GAUSSIAN, PLATEAU };
  enum TResponse
  { FROM_FILE, LINEAR, GAMMA, LOG10, FROM_ROBERTSON } ;
  enum TModel
  { ROBERTSON, DEBEVEC };


  struct config_triple {
      TWeight weights;
      TResponse response_curve;
      TModel model;
      QString CurveFilename;
  };

//returns the PFS HDR stream.
#ifdef _WIN32
void       createHDR(QList<QImage*> &ImageList, const float * arrayofexptime, config_triple* chosen_config, bool antighosting, int iterations, const char *outfname);
#else
QByteArray createHDR(QList<QImage*> &ImageList, const float * arrayofexptime, config_triple* chosen_config, bool antighosting, int iterations);
#endif
#endif
